;  ---------==========----------==========---------=========---------
;      PROGRAM FOR LIFT cONTROLLER
;  ---------==========----------==========---------=========---------
 
F0_3	EQU	P1.0
F0_2	EQU	P1.1
F0_1	EQU	P1.2
F0_0	EQU	P1.3
F0_LED EQU	P2.7

F1_3	EQU	P1.4
F1_2	EQU	P1.5
F1_0	EQU	P1.6
F1_1	EQU	P1.7
F1_LED EQU	P2.6

F2_3	EQU	P3.0
F2_1	EQU	P3.1
F2_0	EQU	P3.2
F2_2	EQU	P3.3
F2_LED EQU	P2.5

F3_2	EQU	P3.4
F3_1	EQU	P3.5
F3_0	EQU	P3.6  
F3_3	EQU	P3.7
F3_LED EQU	P2.4 

DIS_A	EQU	P0.2	
DIS_B	EQU	P0.3	
DIS_C	EQU	P0.4
DIS_D	EQU	P0.6
DIS_E	EQU	P0.5
DIS_F	EQU	P0.1
DIS_G	EQU	P0.0

RLY1	EQU	P2.0
RLY2	EQU	P2.1

DSEG            ; This is internal data memory
ORG     20H     ; Bit adressable memory

FLAGS:  DS      1
CONTROL BIT     FLAGS.0  ; toggles with every new keystroke
NEW     BIT     FLAGS.1  ; Bit set when a new command has been received


COMMAND: DS     1       ; Received command byte
FLOOR:  DS      1       ; Device subaddress
TEMP: DS     1	;Toggle every bit
ANS: DS	1	;
ADDR:	DS	1
STACK:  DS      1       ; Stack begins here
CSEG            ; Code begins here
 
 
;---------==========----------==========---------=========---------
;              PROCESSOR INTERRUPT AND RESET VECTORS
;---------==========----------==========---------=========---------
 
         ORG     00H    ; Reset
;  ---------==========----------==========---------=========---------
;  Main routine. Program execution starts here.
;  ---------==========----------==========---------=========---------    
		MOV SP,#60H
		CLR RLY1
		CLR RLY2
		CALL DELAY
		MOV R2,#16H
		CALL DISP
		MOV P1,#0FFH
		MOV P3,#0FFH
		MOV FLOOR,#00H
		CLR F0_LED
		SETB F1_LED
		SETB F2_LED
		SETB F3_LED
		
		
MAIN:	JNB F0_0,FLR0
		JNB F1_1,FLR1
		JNB F2_2,FLR2
		JB F3_3,MAIN
		AJMP FLR3
		
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&		
;			FLOOR 0
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
FLR0:	MOV TEMP,#00H
		CALL GOTO_FLOOR
		MOV R2,#15H
		CALL DISP
AN3:	JNB F0_1,AN1
		JNB F0_2,AN2
		JB F0_3,AN3		
		MOV TEMP,#03H
		CALL GOTO_FLOOR
		AJMP MAIN		
AN1:	MOV TEMP,#01H
		CALL GOTO_FLOOR
		AJMP MAIN			
AN2:	MOV TEMP,#02H
		CALL GOTO_FLOOR
		MOV R2,#16H
		CALL DISP
		AJMP MAIN			
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&		
;			FLOOR 1
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&		
FLR1:	MOV TEMP,#01H
		CALL GOTO_FLOOR
		MOV R2,#15H
		CALL DISP
BN3:	JNB F1_0,BN1
		JNB F1_2,BN2
		JB F1_3,BN3		
		MOV TEMP,#03H
		CALL GOTO_FLOOR
		AJMP MAIN		
BN1:	MOV TEMP,#00H
		CALL GOTO_FLOOR
		AJMP MAIN			
BN2:	MOV TEMP,#02H
		CALL GOTO_FLOOR
		MOV R2,#16H
		CALL DISP
		AJMP MAIN		
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&		
;			FLOOR 2
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
FLR2:	MOV TEMP,#02H
		CALL GOTO_FLOOR
		MOV R2,#15H
		CALL DISP
CN3:	JNB F2_0,CN1
		JNB F2_1,CN2
		JB F2_3,CN3		
		MOV TEMP,#03H
		CALL GOTO_FLOOR
		AJMP MAIN		
CN1:	MOV TEMP,#00H
		CALL GOTO_FLOOR
		AJMP MAIN			
CN2:	MOV TEMP,#01H
		CALL GOTO_FLOOR
		MOV R2,#16H
		CALL DISP
		AJMP MAIN		
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&		
;			FLOOR 3
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
FLR3:	MOV TEMP,#03H
		CALL GOTO_FLOOR
		MOV R2,#15H
		CALL DISP
DN3:	JNB F3_0,DN1
		JNB F3_1,DN2
		JB F3_2,DN3		
		MOV TEMP,#02H
		CALL GOTO_FLOOR
		AJMP MAIN		
DN1:	MOV TEMP,#00H
		CALL GOTO_FLOOR
		AJMP MAIN			
DN2:	MOV TEMP,#01H
		CALL GOTO_FLOOR
		MOV R2,#16H
		CALL DISP
		AJMP MAIN		
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
GOTO_FLOOR:
		MOV R2,FLOOR
		CJNE R2,#00H,SD1
		CLR F0_LED
		SETB F1_LED
		SETB F2_LED
		SETB F3_LED
		AJMP SD
SD1:	CJNE R2,#01H,SD2
		SETB F0_LED
		CLR F1_LED
		SETB F2_LED
		SETB F3_LED
		AJMP SD
SD2:	CJNE R2,#02H,SD3
		SETB F0_LED
		SETB F1_LED
		CLR F2_LED
		SETB F3_LED
		AJMP SD
SD3:	CJNE R2,#03H,SD
		SETB F0_LED
		SETB F1_LED
		SETB F2_LED
		CLR F3_LED		
SD:	MOV A,TEMP
		CJNE A,FLOOR,DS1
		CALL OFF
		RET
DS1:	JNC DS2
		CALL DOWN
		DEC FLOOR
		MOV R2,FLOOR
		CALL DISP
		AJMP GOTO_FLOOR
DS2:	CALL UP
		INC FLOOR
		MOV R2,FLOOR
		CALL DISP
		AJMP GOTO_FLOOR
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&				
UP:	CLR RLY1
		SETB RLY2
		CALL DELAYS
		RET
	
DOWN:	SETB RLY1
		CLR RLY2
		CALL DELAYS	
		RET

OFF:	CLR RLY1
		CLR RLY2
		CALL DELAY
		RET
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
DELAY:
		MOV R5,#0FFH
RA:	MOV R6,#0FFH
		DJNZ R6,$
		DJNZ R5,RA
		RET
   
DELAYS:
		MOV R4,#13H
RX2:	MOV R5,#0FFH
RX1:	MOV R6,#0FFH
RX:	NOP
		DJNZ R6,RX
		DJNZ R5,RX1
		DJNZ R4,RX2
		RET
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
; 	7 SEGMENT DISPLAY ROUTINE
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
DISP:
	CJNE R2,#00H,AAS1
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	SETB DIS_G
	RET
AAS1:	CJNE R2,#01H,AS2
	CLR DIS_B
	CLR DIS_C
	SETB DIS_A
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	SETB DIS_G
	RET
AS2:	CJNE R2,#02H,AS3
	CLR DIS_A
	CLR DIS_B
	CLR DIS_D
	CLR DIS_E
	CLR DIS_G
	SETB DIS_C
	SETB DIS_F
	RET
AS3:	CJNE R2,#03H,AS4
	CLR DIS_A    
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_G
	SETB DIS_E
	SETB DIS_F
	RET
AS4:	CJNE R2,#04H,AS5
	CLR DIS_B
	CLR DIS_C
	CLR DIS_F
	CLR DIS_G
	SETB DIS_A
	SETB DIS_D
	SETB DIS_E
	RET
AS5:	CJNE R2,#05H,AS6
	CLR DIS_A
	CLR DIS_C
	CLR DIS_D
	CLR DIS_F
	CLR DIS_G
	SETB  DIS_B
	SETB DIS_E
	RET
AS6:	CJNE R2,#06H,AS7
	CLR DIS_A
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	SETB DIS_B
	RET
AS7:	CJNE R2,#07H,AS8
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	SETB DIS_G
	RET
AS8:	CJNE R2,#08H,AS9
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	RET
AS9:	CJNE R2,#09H,AS10
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_F
	CLR DIS_G
	SETB DIS_E
	RET
AS10:	CJNE R2,#15H,AS11		;symbol for P
	CLR DIS_A
	CLR DIS_B
	SETB DIS_C
	SETB DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	RET
AS11:	
	CJNE R2,#16H,AS12		;symbol for F
	CLR DIS_A
	SETB DIS_B
	SETB DIS_C
	SETB DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	RET
AS12:	
	RET
;**********************************************************	
   END

    
